/***************************************************************************
 *   Copyright (C) 2004 by Nikola Kotur                                    *
 *   kotnik@ns-linux.org                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

//
//	VERSION: 0.1
//

#ifndef MCCONF_H
#define MCCONF_H

#define NKR08_MARK "NKR-0.8";

#include <qstring.h>
#include <qfile.h>

/**
Class for handling config file.

@author Nikola Kotur
*/
class McConf
{
public:
	McConf();
    ~McConf();

	void loadSettings();
	void saveSettings();

	// Home dir for program ~/.nkrecnik/
	QString progDir();
	QString homeDir();

	// Here goes all the settings as public variables:
	int win_x, win_y;			// X, Y coords of main win.
	int tab_left, tab_right;	// Left and right widths of table fields.
	int clip_store_trans;		// Store translation selected 0-no 1-yes.
	int clip_store_format;		// Store in format selected 0-no 1-yes.
	QString clip_format;		// Clipboard format.
	QString add_dict;			// Path to additional dictionary
	int kde_mode;				// KDE mode 0-off 1-on.

private:
	QString path;
	QFile setFile;
	QString progDirPath;
	QString home_dir;


	void loadDefaults();
//	void oldVersion(QString);
	void oldVersion();
};

#endif
