/***************************************************************************
 *   Copyright (C) 2004 by Nikola Kotur                                    *
 *   kotnik@ns-linux.org                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

 //
 //	VERSION: 0.1
 //


#ifndef MCDICT_H
#define MCDICT_H

#define KDE_STYLE 1
#define PLAIN_STYLE 2
#define EN2SR 1
#define SR2EN 0

#include <kstddirs.h>

#include <qstring.h>


/**
Handles dictionary search

@author Nikola Kotur
*/
class McDict{

public:
	McDict();
	McDict(QString place, int style);
    ~McDict();
	QString whereIsDict();
	int find(QString query);
	QString getWord(int index, int column);
	void dictChange(int dict);
	void setSort(bool);
	bool writeEntry(QString, QString);
	bool doesExist();

private:
	QString dictPath;
	KStandardDirs *dirs;

	void init(void);

	// Search variables:
	int usedDict;
	bool doSort;
	QString firstWords[100];
	QString secondWords[100];
	char cLine[400];
	char cFirst[400];
	char cSecond[400];
	int wordCount[100];

	// Search functions:
	void clearWords();
	void parseWords(QString *line, QString *first, QString *second);
	bool isHere(QString *dictWord, QString *userWord);
	void putWords(QString first, QString second, int index);
	void swapWords(int index1, int index2);
	void sortWords(int num);
	void countWords(int num);
};

#endif
