/***************************************************************************
 *   Copyright (C) 2004 by Nikola Kotur                                    *
 *   kotnik@ns-linux.org                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef _NKRECNIK_H_
#define _NKRECNIK_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qsize.h>
#include <qpoint.h>
#include <qevent.h>
#include <qstring.h>

#include "nkrGUI.h"
#include "mcdict.h"
#include "mcconf.h"

/**
 * @short Application Main Window
 * @author Nikola Kotur <kotnik@ns-linux.org>
 * @version 0.8
 */
class NKRecnik : public nkrGUI
{
    Q_OBJECT

public:
    NKRecnik(QWidget *parent=0, const char *name=0);
    ~NKRecnik();

protected:
	void keyPressEvent(QKeyEvent *);

public slots:
	virtual void retPressed();
	virtual void rbEnToogled(int);
	virtual void rbSrToogled(int);
	virtual void tableClicked(int, int, int, const QPoint&);
	virtual void applySetClicked();
	virtual void saveSetClicked();
	virtual void helpSetClicked();
	virtual void browseSetClicked();
	virtual void updateClicked();
	virtual void setStoreToggled(bool);
	virtual void setFormatToggled(bool);
	//virtual void guiDestroyed(QObject*);
	//virtual void focusInEvent(QFocusEvent *); // 4 Focus translation.
	void copy();
	void inverse();

private:
	// Search & Sort functions:
	void sortWords(int);
	void countWords(int);
	void swapWords(int, int);

	// Search & Sort variables:
	QString allWords[400][2]; // holds strings.
	int countAllWords[400];  // holds number of words in string allWords[i][0].
	int numAllWords;  // holds number of translations found.

	// Dictionaries:
	McDict *Dict;
	McDict *updateDict;
	McDict *additionalDict;
	McDict *kdeDict;

	// Configuration:
	McConf *config;

	// Santa's little helpers:
	QClipboard *clipBoard;	// Clipboard for copy function.
	QSize tabSize;			// Table width.
	int curRow, curCol;		// Table row and column.
	bool addDictLoaded;		// Is additional dictionary loaded.
	bool inKdeMode;			// We're in KDE mode.
};

#endif // _NKRECNIK_H_
